Type Ant
	Field x#
	Field y#
	
	Field l#
	Field phi#
	
	Field vx#
	Field vy#
	
	Field carry.Sand
End Type

Type Sand
	Field x#
	Field y#
	
	Field vy#
End Type

Function createAnt.Ant(x,y)
	Local A.Ant=New Ant
	
	A\x=x
	A\y=y
	
	A\l=10
	A\phi=0
	
	A\vx=0
	A\vy=0
	
	Return A
End Function

Function drawAnt(A.Ant)
	Local Dx#, Dy#
	
	;Dx=Cos(-A\phi)*A\l/2
	;Dy=Sin(-A\phi)*A\l/2
	;Line A\x-Dx,A\y-Dy,A\x+Dx,A\y+Dy
	
	If A\vx>0
		DrawImage AntImage1,A\x,A\y
	Else
		DrawImage AntImage2,A\x,A\y
	EndIf
End Function

Const G#=0.4
Function controlAnt(Anton.Ant)
	If Anton\y<500
		Anton\vy=Anton\vy+G
		
		If isAntOnAnt(Anton)
			Anton\vy=0
		EndIf
		
		If isAntOnSand(Anton)
			Anton\vy=0
		EndIf
	Else
		Anton\y=500
		Anton\vy=0
	EndIf
	Anton\y=Anton\y+Anton\vy
	
	Arlon.Ant=isAntRunningIntoAnt(Anton)
	Anton\x=Anton\x+Anton\vx
	
	If Arlon<>Null
		Anton\y=Anton\y-10
	EndIf
	
	If (Anton\x>750 And Anton\vx>0) Or (Anton\x<50 And Anton\vx<0)
		Anton\vx=-Anton\vx
	EndIf
	
	Sam.Sand=isAntRunningIntoSand(Anton)
	If Sam<>Null And isSandCarried(Sam)=False
		Anton\y=Anton\y-6
	EndIf
	
	If Anton\carry=Null
		If Not isSandCarried(Sam)
			If buildSite=0
				If Anton\x<400
					Anton\carry=Sam
					Anton\vx=-Anton\vx
				EndIf
			Else
				If Anton\x>400
					Anton\carry=Sam
					Anton\vx=-Anton\vx
				EndIf
			EndIf
		EndIf
	Else
		Anton\carry\x=Anton\x+Sgn(Anton\vx)*Anton\l*0.8
		Anton\carry\y=Anton\y-1
	EndIf
	
	If isAtDropPosition(Anton)
		Anton\vx=-Anton\vx
	EndIf
End Function

Function isAntOnAnt(Anton.Ant)
	For A.Ant=Each Ant
		If A<>Anton
			If RectsOverlap(Anton\x-Anton\l/2,Anton\y-5,Anton\l,10 , A\x-A\l/2,A\y-5,A\l,10)
				If Anton\y<A\y
					Return True
				EndIf
			EndIf
		EndIf
	Next
	
	Return False
End Function

Function isAntRunningIntoAnt.Ant(Anton.Ant)
	For A.Ant=Each Ant
		If A<>Anton
			If RectsOverlap(Anton\x-Anton\l/2,Anton\y-3,Anton\l,6 , A\x-A\l/2,A\y-3,A\l,6)
				Return A
			EndIf
		EndIf
	Next
	
	Return Null
End Function

Function isAntOnSand(Anton.Ant)
	For S.Sand=Each Sand
		If RectsOverlap(Anton\x-Anton\l/2,Anton\y-5,Anton\l,10 , S\x-3,S\y-3,6,6)
			If Anton\y<S\y And isSandCarried(S)=False
				Return True
			EndIf
		EndIf
	Next
	
	Return False
End Function

Function isAntRunningIntoSand.Sand(Anton.Ant)
	For S.Sand=Each Sand
		If RectsOverlap(Anton\x-Anton\l/2,Anton\y-3,Anton\l,6 , S\x-3,S\y-3,6,6)
			Return S
		EndIf
	Next
	
	Return Null
End Function

Function drawSandTotal()
	For S.Sand=Each Sand
		;WritePixel S\x,S\y,255*$10000+255*$100
		DrawImage SandImage,S\x,S\y
	Next
End Function

Function controlSandTotal()
	For S.Sand=Each Sand
		S\x=Int(S\x/6)*6
		
		S\vy=S\vy+G
		S\y=S\y+S\vy
		
		Sam.Sand=isSandOnSand(S)
		If Sam<>Null
			S\vy=0
			
			S\y=Sam\y-6
		EndIf
		
		If S\y>500
			S\vy=0
			
			S\y=500
		EndIf
	Next
End Function

Function isSandOnSand.Sand(Sam.Sand)
	For S.Sand=Each Sand
		If S<>Sam
			If RectsOverlap(Sam\x-3,Sam\y-3,6,6 , S\x-3,S\y-3,6,6)
				If S\y>Sam\y
					Return S
				EndIf
			EndIf
		EndIf
	Next
	
	Return Null
End Function

Function isAtDropPosition(Anton.Ant)
	If Anton\carry=Null
		Return False
	EndIf
	
	If Anton\carry=Null
		Return False
	EndIf
	
	If buildSite=0
		notice=False
		
		nextPosX=710
		nextPosY=500
		
		For y=10 To 0 Step -1
			For x=650+y*6 To 650-y*6 Step -6
				If notice
					nextPosX=x
					nextPosY=440+y*6
					
					notice=False
				EndIf
				
				Sam.Sand=isSandAtPos(x,440+y*6)
				If Sam<>Null And isSandCarried(Sam)=False
					notice=True
				EndIf
			Next
		Next
	Else
		notice=False
		
		nextPosX=90
		nextPosY=500
		
		For y=10 To 0 Step -1
			For x=150-y*6 To 150+y*6 Step 6
				If notice
					nextPosX=x
					nextPosY=440+y*6
					
					notice=False
				EndIf
				
				Sam.Sand=isSandAtPos(x,440+y*6)
				If Sam<>Null And isSandCarried(Sam)=False
					notice=True
				EndIf
			Next
		Next
	EndIf
	
	If Abs(Anton\x-nextPosX)<6 And Abs(Anton\y-nextPosY)<12
		Anton\carry\x=nextPosX
		Anton\carry\y=nextPosY
		
		Sam.Sand=isSandAtPos(nextPosX,nextPosY)
		
		Anton\carry=Null
		
		Return True
	EndIf
	
	; _ spinnt rum bei zuvielen ameisen, gleichzeitiges droppen und so
	; von daher:
	
	chance=1
	
	X=Int(Anton\x/6)*6
	For Y=500 To 0 Step -6
		Sam.Sand=isSandAtPos(x,y)
		If Sam<>Null And isSandCarried(Sam)
			chance=chance+1
		EndIf
	Next
	
	If buildSite=0
		If Anton\x>400
			If Rand(1,100*chance)=1
				Anton\carry=Null
				Return True
			EndIf
		EndIf
	Else
		If Anton\x<400
			If Rand(1,100*chance)=1
				Anton\carry=Null
				Return True
			EndIf
		EndIf
	EndIf
	
	Return False
End Function

Function isSandCarried(Sam.Sand)
	For A.Ant=Each Ant
		If A\carry=Sam
			Return True
		EndIf
	Next
	
	Return False
End Function

Function isSandAtPos.Sand(x,y)
	For S.Sand=Each Sand
		If Abs(S\x-x)<3 And Abs(S\y-y)<3
			Return S
		EndIf
	Next
	
	Return Null
End Function

Function checkBuildingSite()
	thereIsStillSand=False
	
	If buildSite=0
		For y=0 To 10
			For x=150-y*6 To 150+y*6 Step 6
				Sam.Sand=isSandAtPos(x,440+y*6)
				If Sam<>Null And isSandCarried(Sam)=False
					thereIsStillSand=True
				EndIf
			Next
		Next
	Else
		For y=0 To 10
			For x=650-y*6 To 650+y*6 Step 6
				Sam.Sand=isSandAtPos(x,440+y*6)
				If Sam<>Null And isSandCarried(Sam)=False
					thereIsStillSand=True
				EndIf
			Next
		Next
	EndIf
	
	If Not thereIsStillSand
		buildSite=1-buildSite
	EndIf
End Function

Global buildSite=0, AntImage1, AntImage2, SandImage
Function main()
	Graphics 800,600,0,2
	SetBuffer BackBuffer()
	
	BackGround=LoadImage("Ameisenhugel.png")
	
	AntImage=LoadImage("Ant.png")
	MaskImage AntImage,255,200,200
	ScaleImage AntImage,.03,.03
	MidHandle AntImage
	
	AntImage1=CopyImage(AntImage)
	
	AntImage2=CopyImage(AntImage)
	ScaleImage AntImage2,-1,1
	
	SandImage=LoadImage("Sand.png")
	MaskImage SandImage,255,200,200
	ScaleImage SandImage,0.167,0.167
	MidHandle SandImage
	
	For x=200 To 600 Step 5
		A.Ant=createAnt(x,300)
		
		A\vx=Rand(-2.00,2.00)+0.5
	Next
	
	For y=0 To 10
		For x=150-y*6 To 150+y*6 Step 6
			S.Sand=New Sand
			
			S\x=x
			S\y=440+y*6
		Next
	Next
	
	timer=CreateTimer(60)
	While Not KeyHit(1)
		DrawImage Background,0,0
		
		checkBuildingSite()
		
		For A.Ant=Each Ant
			drawAnt(A)
			controlAnt(A)
		Next
		
		drawSandTotal()
		controlSandTotal()
		
		Flip 0
		WaitTimer(timer)
		Cls
	Wend
End Function

main()
End
;~IDEal Editor Parameters:
;~C#Blitz3D