AppTitle "Game of Life BCC #35"

Graphics 800, 600, 32, 2
SetBuffer BackBuffer()


Global XGroesse = 80
Global YGroesse = 60
Global Lebensdauer = 15


Global FTimer = CreateTimer(50)
Global Showtimer = 300
Global Showstart = MilliSecs()

Global AnzahlZellen = 0

Global Xsize
Global Ysize
Global GT
Global Haeufig = 3

Local XEingabe$ 
Local YEingabe$
Local LiveTime$
Local Haeufigkeit$

Print "Du kannst nun die Groesse der Lebenswiese eingeben"
Print "Bitte nimm dazu einen gemeinsamen Teiler von 800 und 600 und teil "
Print "jeweilsbeide Zahlen durch diese Zahl. Das Ergebnis gibst du ein.
Print "Beispiel: Teiler: 10 800/10 = 80 und 600/10 = 60, also 80 und 60 eingeben."
Print "Es ist ratsam die Lebensdauer nicht unter 10 einzustellen!"
Print "Zuletzt gib bitte an, wie hoch die Wahrscheinlichkeit sein soll, dass viele "
Print "Zellen zu Beginn erzeigt werden sollen. Destor hher die Zahl desto wahrscheinlicher."
Print "Ratsam: Desto groesser die Map, desto hoeher die Wahrscheinlichkeit.
Print ""
XEingabe$ = Input$("Hier die XGroesse eingeben (800): ")
YEingabe$ = Input$("Hier die YGroesse eingeben (600): ")
LiveTime$ = Input$("Bitte gib hier die Lebensdauer der Zellen an(zwischen 1 und (2^31)): ")
Haeufigkeit$ = Input("Bitte gib hier die Entstehungswahrscheinlichkeit an (zwischen 3 und 2^31): ")


XGroesse = Int(XEingabe$)
YGroesse = Int(YEingabe$)
Lebensdauer = Int(LiveTime$)
Haeufig = Int(Haeufigkeit$)
GT = (800/XGroesse)



Dim SpielFeld(XGroesse,YGroesse)

SeedRnd MilliSecs()
Xsize = (GraphicsWidth()/XGroesse)
Ysize = (GraphicsHeight()/YGroesse)

Global XMouse, YMouse
Global MH

ClsColor 35, 35, 35

SetCells()
Showstart = MilliSecs()

Repeat 
	
	WaitTimer(FTimer)
	Cls
	
	XMouse = MouseX()
	YMouse = MouseY()
	
	DrawCells()
	DrawMouse()
	AppTitle "ZellenAnzahl: " + AnzahlZellen
	
	If ((Showtimer+Showstart) < MilliSecs()) Then
		CheckCells()
		Showstart =MilliSecs()
	EndIf
	
	
	Flip 0
	
Until KeyDown(1)


Function DrawMouse()
	Local iX, iY
	Local xpos, ypos
	Local xReal, yReal
	Local MX, MY
	
	MX = XMouse/GT
	MY = YMouse/GT
	
	For iX = -1 To 1
		For iY = -1 To 1
			
			xpos = (XMouse + (iX*Xsize))
			ypos = (YMouse + (iY*Ysize))
			
			Color 120, 120, 250 
			
			Rect xpos, ypos, Xsize-1, Ysize-1, 1
			
		Next
	Next
	
	If MouseDown(1) Then
		If ((MX >= 1) And (MX <= (XGroesse-1))) Then
			If ((MY >= 1) And (MY <= (YGroesse-1))) Then
				
				For iX = -1 To 1
					For iY = -1 To 1
						
						xReal = MX + iX
						yReal = MY + iY
						
						If SpielFeld(xReal, yReal) > 0 Then AnzahlZellen = AnzahlZellen - 1
							
						SpielFeld(xReal, yReal) = -1
							
						
					Next
				Next
				
			EndIf
		EndIf
	EndIf
	
End Function


Function CheckCells()
	Local XIndex, YIndex
	Local TempX, TempY
	Local NeighbourX, NeighbourY
	Local Amount
	
	
	For YIndex = 0 To (YGroesse-1)
		For XIndex = 0 To (XGroesse-1)
			Amount = 0
			
			Amount = CheckNeighbours(XIndex, YIndex)
			
			If (SpielFeld(XIndex,YIndex)>=1) Then
				
				If ((Amount > 3) Or (Amount < 2)) Then
					
					SpielFeld(XIndex,YIndex) = 0
					AnzahlZellen = AnzahlZellen - 1
					
				Else
					
					SpielFeld(XIndex, YIndex) = SpielFeld(XIndex, YIndex) + 1
					
				EndIf
				
				
			ElseIf (SpielFeld(XIndex,YIndex)=0) Then
				
				If (Amount = 3) Then
					
					SpielFeld(XIndex,YIndex) = 1
					AnzahlZellen = AnzahlZellen + 1
					
				EndIf
				
			EndIf
			
			If SpielFeld(XIndex, YIndex) >= Lebensdauer Then 
				SpielFeld(XIndex, YIndex) = 0 
				AnzahlZellen = AnzahlZellen - 1
			EndIf
			
		Next
	Next
	
End Function

Function DrawCells()
	Local XIndex, YIndex
	Local XPos, YPos
	Local Amount = 0
	
	For YIndex = 0 To (YGroesse-1)
		For XIndex = 0 To (XGroesse-1)
			
			XPos = (XIndex*(GraphicsWidth()/XGroesse))
			YPos = (YIndex*(GraphicsHeight()/YGroesse))
			
			If SpielFeld(XIndex,YIndex) >= 1 Then
				
				Amount = CheckNeighbours(XIndex, YIndex)
				
				If (((Amount > 3) Or (Amount < 2)) Or (SpielFeld(XIndex,YIndex) >= (Lebensdauer-1))) Then
					Color 250, 120, 120
				Else
					Color 120, 250, 120
				EndIf
				
				Rect XPos, YPos, Xsize-1, Ysize-1
				
			ElseIf SpielFeld(XIndex, YIndex) = -1 Then
				
				Color 120, 120,250
				
				Rect XPos, YPos, Xsize-1, Ysize-1, 1
				
			EndIf
		Next
	Next
	
End Function

Function SetCells()
	Local XIndex, YIndex
	Local Zufallsetzen
	
	For YIndex = 0 To (YGroesse-1)
		For XIndex = 0 To (XGroesse-1)
			
			Zufallsetzen = Rand(-(XGroesse/2),Haeufig)
			
			If Zufallsetzen  >0 Then 
				
				SpielFeld(XIndex,YIndex) = 1
				
				AnzahlZellen = AnzahlZellen + 1
				
			ElseIf Zufallsetzen <= 0 Then
				
				SpielFeld(XIndex,YIndex) = 0
				
			EndIf
			
		Next
	Next
	
End Function

Function CheckNeighbours(xindex, yindex)
	Local TempX, TempY
	Local NeighbourX, NeighbourY
	Local AmountNeighbours = 0
	
	For TempY = 1 To -1 Step -1
		For TempX = 1 To -1 Step -1
			
			NeighbourX = xindex - TempX
			NeighbourY = yindex - TempY
			
			If ((NeighbourX >= 0) And (NeighbourX <= XGroesse)) Then
				If ((NeighbourY >=0) And (NeighbourY <= YGroesse)) Then
					
					If Not((NeighbourX = xindex) And (NeighbourY = yindex)) Then
						
						If (SpielFeld(NeighbourX,NeighbourY) >= 1) Then
							AmountNeighbours = AmountNeighbours + 1
						EndIf
						
					EndIf	
					
				EndIf
			EndIf
			
		Next
	Next
	
	Return AmountNeighbours
	
	
End Function




;~IDEal Editor Parameters:
;~F#86#B6#D9#F3
;~C#Blitz3D