
SuperStrict
SeedRnd MilliSecs()
Const C_Screen_Width:Int=1024,C_Screen_Height:Int=768

'SetGraphicsDriver GLMax2DDriver()
SetGraphicsDriver D3D9Max2DDriver()
Graphics(C_Screen_Width,C_Screen_Height,0,60)
AutoMidHandle True

'Step counter
Global G_Step:Int,G_CO:Int=100000,G_O:Int=50,G_Light:Int=100,G_Radiation:Int=100,G_CellImg:TImage=LoadImage("Cell.png"),G_cCell:Int

Local rg:Byte[]=[0:Byte,255:Byte,128:Byte,128:Byte,0:Byte,1:Byte,12:Byte,255:Byte,255:Byte,13:Byte,16:Byte,2:Byte,1:Byte,17:Byte,18:Byte,10:Byte,255:Byte,19:Byte,14:Byte,100:Byte,5:Byte,15:Byte,20:Byte,50:Byte,9:Byte,50:Byte,200:Byte,21:Byte,24:Byte,25:Byte,0:Byte,0:Byte,50:Byte,25:Byte]
Local BDNA:TDNA=New TDNA
BDNA.Stick(rg)
Local Cell:TCell=TCell.Create(C_Screen_Width/2,C_Screen_Height/2,BDNA)
Cell._En=255
Cell._Sat=100
Cell._H=5
Cell=Null

Repeat
	TCell.UpdateAll()
	G_Step:+1
	If KeyHit(KEY_ESCAPE) Then End
	SetAlpha 1.0
	SetColor 255,255,255
	DrawText "Cells: "+G_cCell,10,110
	DrawText "Carbon dioxyde: "+G_CO,10,120
	If KeyDown(KEY_F) Then G_CO:+1
	If KeyDown(KEY_V) And G_CO>0 Then G_CO:-1
	DrawText "Oxygen: "+G_O,10,130
	If KeyDown(KEY_D) Then G_O:+1
	If KeyDown(KEY_C) And G_O>0 Then G_O:-1
	DrawText "Light: "+G_Light,10,140
	If KeyDown(KEY_S) Then G_Light:+1
	If KeyDown(KEY_X) And G_Light>0 Then G_Light:-1
	DrawText "Radiation: "+G_Radiation,10,150
	If KeyDown(KEY_A) Then G_Radiation:+1
	If KeyDown(KEY_Y) And G_Radiation>0 Then G_Radiation:-1
	Flip
	Cls
Forever

Type TCell
	
	Global G_rg:TList=CreateList()
	
	Const C_MovRange:Byte=4
	
	Const C_cAttribs:Byte=33
	
	Const C_i_Color_A:Byte=0
	Const C_i_Color_R:Byte=1
	Const C_i_Color_G:Byte=2
	Const C_i_Color_B:Byte=3
	
	Const C_i_Volume_Minimum:Byte=4
	
	Const C_i_Behaviour_Aggressivity:Byte=5
	
	Const C_i_Repair_Rate:Byte=6
	Const C_i_Repair_Value:Byte=7
	Const C_i_Repair_Utilization:Byte=31
	
	Const C_i_Eating_DigestionSpeed:Byte=8
	Const C_i_Eating_UtilizationRate:Byte=9
	Const C_i_Eating_Capacity:Byte=10
	
	Const C_i_Storage_Nutrients:Byte=11
	Const C_i_Storage_Energy:Byte=12
	
	Const C_i_Photosynthesis_Speed:Byte=13
	Const C_i_Photosynthesis_Utilizationrate:Byte=14
	
	Const C_i_Movement_Speed:Byte=15
	Const C_i_Movement_StepCost:Byte=16
	
	Const C_i_Energysynthesis_Ratio:Byte=17
	Const C_i_Energysynthesis_Utilization:Byte=18
	
	Const C_i_Growth_Threshold_Nutrients:Byte=19
	Const C_i_Growth_Threshold_Energy:Byte=20
	Const C_i_Growth_ProcessSpeed:Byte=21
	Const C_i_Growth_InterphaseDuration:Byte=22
	
	Const C_i_Adaptiveness_MutationResistance:Byte=23
	Const C_i_Adaptiveness_AbsorptionAttendance:Byte=25
	
	Const C_i_PhysCondition_Health:Byte=26
	Const C_i_PhysCondition_Defense:Byte=27
	Const C_i_PhysCondition_Offense:Byte=28
	Const C_i_PhysCondition_RadiationResistance:Byte=32
	
	Const C_i_Senses_Radius:Byte=29
	Const C_i_Senses_Intensity:Byte=30
	
	Const C_TimeStep:Byte=60
	Const C_DNA_Damage_Threshold:Byte=50
	
'	Const C_i_:Byte=
	
	Field X:Float,Y:Float,Size:Float,_Split:Int,VX:Float,VY:Float
	Field _Sat:Short,_En:Short,_H:Short,_D:Byte,S:Byte,A:Byte,H:Byte,T:TCell,R:Int,E:Byte,C:Byte
	Field _rgDNA:TDNA,_rgAttribs:Byte[C_cAttribs],_Phero:Short
	
	Function Create:TCell(X:Float,Y:Float,DNA:TDNA)
		Local Cell:TCell=New TCell
		G_rg.AddLast(Cell)
		Cell.X=X
		Cell.Y=Y
		Cell.A=10
		Cell._rgDNA=DNA
		Cell._rgDNA.ParseDNA(Cell)
		'Apply DNA
		Cell._H=Cell._rgAttribs[C_i_PhysCondition_Health]
		G_cCell:+1
		Return Cell
	End Function
	
	Function UpdateAll()
		Local DX:Int,DY:Int
		For Local t:TCell=EachIn G_rg
			t.Update()
			Local r:Byte[]=t._rgAttribs
			SetColor(r[C_i_Color_R],r[C_i_Color_G],r[C_i_Color_B])
			DrawImage(G_CellImg,t.X,t.Y)
			DrawText t._rgDNA._Damage,10+DX*30,10+DY*10
			DY:+1
			If DY=10 Then DY=0;DX:+1
			If t._D=True Then G_CO:+Float(t.Size)*.3;G_O:+Float(t.Size)*.3;ListRemove(G_rg,t);G_cCell:-1
		Next
	End Function
	
	Method Update()
		Local r:Byte[]=Self._rgAttribs,t:Byte,F:TCell
		If Self._H<=0 Or Self._En<=0 Or Self._rgDNA._Damage>C_DNA_Damage_Threshold Then Self._D=True;Return
		Self.A:-1
		If Self.A=0 Then Self.A=C_TimeStep;Self._En:-1
		'Radiational damages
		If Self.A Mod (C_TimeStep/3)=0 And Rand(-G_Radiation,r[C_i_PhysCondition_Radiationresistance])<0 Then Self._rgDNA._Damage:+1
		
		SetAlpha 1.0
		SetScale 1,1
		SetColor 255,255,255
		Rem
		DrawText Self._En,10,10
		DrawText Self._Sat,10,20
		DrawText Self._H,10,30
		DrawText Self.A,10,40
		DrawText Self._Phero,10,50
		DrawText r[C_i_Growth_InterphaseDuration],40,10
		DrawText Self._Split,40,20
		DrawText G_Step,40,30
		DrawText G_Step-Self._Split,40,40
		DrawText r[C_i_Growth_ProcessSpeed],40,50
		DrawText Self.S,40,60
		DrawText Self._rgDNA._Damage,10,10
		DrawText Self._H,10,20
		DrawText Self.A,10,30
		DrawText r[C_i_PhysCondition_RadiationResistance],10,40
		DrawText G_Radiation,10,50
		End Rem
		
		'Targeting
		If Self.T=Null
			If Self.A Mod 4=0 Then Self.R=(Self.R+Rand(-C_MovRange,C_MovRange)+360) Mod 360
			For F=EachIn G_rg
				If F<>Self And InRange(Self._Phero,F._Phero,16)
					If InRangeXY(Self.X,Self.Y,F.X,F.Y,r[C_i_Senses_Radius])
						If Rand(0,255)<r[C_i_Behaviour_Aggressivity] Then Self.ST(F);Exit
					End If	
				End If
			Next
		Else
			If Self.T.H<0 
				Self.T=Null
			Else
				Self.R=ATan2(Self.T.Y-Self.Y,Self.T.X-Self.X)
			End If			
		End If
		If r[C_i_Movement_Speed]
			Self.X:+Cos(Self.R)*r[C_i_Movement_Speed]
			Self.Y:+Sin(Self.R)*r[C_i_Movement_Speed]
			Self._En:-r[C_i_Movement_StepCost]
			Self.X=(Self.X+C_Screen_Width) Mod C_Screen_Width
			Self.Y=(Self.Y+C_Screen_Height) Mod C_Screen_Height
		End If
		
		'Eating & Fighting
		If Self.E
			Self.E:-1
			If Self.E=0
				Self.C=F._Sat
				If Self.C>r[C_i_Eating_Capacity] Then Self.C=r[C_i_Eating_Capacity]
				Self._Sat:+Float(Self.C*r[C_i_Eating_UtilizationRate]/32.0)
			End If
		Else
			If r[C_i_Eating_DigestionSpeed] And InRangeXY(Self.X,Self.Y,Self.T.X,Self.T.Y,20) And Self.T<>Null
				F=Self.T
				If r[C_i_PhysCondition_Offense]>F._rgAttribs[C_i_PhysCondition_Offense]
					F.H:-Ceil(r[C_i_PhysCondition_Offense]/F._rgAttribs[C_i_PhysCondition_Defense])
					If F.H<=0
						Self.E=255-r[C_i_Eating_DigestionSpeed];Self.ST(Null)
					End If
				Else
					Self.ST(Null)
				End If
			End If		
		End If
		
		'Photosynth
		t=Float(G_light*r[C_i_Photosynthesis_Speed])/500.0
		If t And G_CO>0 And Self._Sat<r[C_i_Storage_Nutrients]
			G_CO:-t
			If G_CO<0
				G_O:+t+G_CO-1
				G_CO=0
			Else
				G_O:+t
			End If
			Self._Sat:+t*Int(100.0*Float(r[C_i_Photosynthesis_UtilizationRate])/255.0)+1
		End If
		
		'Energy Synthesis
		t=Float(50*r[C_i_EnergySynthesis_Ratio])/255.0
		If Self._Sat>0 And Self._En<10 And t And G_O>0
			G_O:-t
			If G_O<0
				G_CO:+t+G_O-1
				G_O=0
			Else
				G_CO:+t
			End If
			Self._En:+t*Int(100.0*Float(r[C_i_EnergySynthesis_Utilization])/255.0)+1
			If t/10=0 Then Self._Sat:-1 Else Self._Sat:-t/10
		End If
		
		'Overflows
		If Self._Sat>r[C_i_Storage_Nutrients] Then Self._Sat=r[C_i_Storage_Nutrients]
		If Self._En>r[C_i_Storage_Energy] Then Self._En=r[C_i_Storage_Energy]
		
		'Process of splitting
		If Self.S
			Self.S:-1
			If Self.S=0
				Local D:TDNA=Self._rgDNA.Copy()
				'Evolution and Mutation
				Local r:Byte[]=D._rg,cch:Int=r.length,i:Int,C:Byte,G:Byte
				For i=0 Until cch
					C=Sgn(Rand(-G_Radiation,r[C_i_Adaptiveness_Mutationresistance]))
					Select r[i]
						Case TDNA.C_Color_B
							If Rand(0,-G/3)=0 Then r[i+Rand(1,TDNA.C_Color_L)]:+C
							i:+TDNA.C_Color_L+1
						Case TDNA.C_SaturationVol_B
							If Rand(0,-G/3)=0 Then r[i+Rand(1,TDNA.C_SaturationVol_L)]:+C
							i:+TDNA.C_SaturationVol_L+1
						Case TDNA.C_Behaviour_B
							If Rand(0,-G/3)=0 Then r[i+Rand(1,TDNA.C_Behaviour_L)]:+C
							i:+TDNA.C_Behaviour_L+1
						Case TDNA.C_Repair_B
							If Rand(0,-G/3)=0 Then r[i+Rand(1,TDNA.C_Repair_L)]:+C
							i:+TDNA.C_Repair_L+1
						Case TDNA.C_Eating_B
							If Rand(0,-G/3)=0 Then r[i+Rand(1,TDNA.C_Eating_L)]:+C
							i:+TDNA.C_Eating_L+1
						Case TDNA.C_Storage_B
							If Rand(0,-G/3)=0 Then r[i+Rand(1,TDNA.C_Storage_L)]:+C
							i:+TDNA.C_Storage_L+1
						Case TDNA.C_Photosynthesis_B
							If Rand(0,-G/3)=0 Then r[i+Rand(1,TDNA.C_Photosynthesis_L)]:+C
							i:+TDNA.C_Photosynthesis_L+1
						Case TDNA.C_EnergySynth_B
							If Rand(0,-G/3)=0 Then r[i+Rand(1,TDNA.C_EnergySynth_L)]:+C
							i:+TDNA.C_EnergySynth_L+1
						Case TDNA.C_Growth_B
							If Rand(0,-G/3)=0 Then r[i+Rand(1,TDNA.C_Growth_L)]:+C
							i:+TDNA.C_Growth_L+1
						Case TDNA.C_Modification_B
							If Rand(0,-G/3)=0 Then r[i+Rand(1,TDNA.C_Modification_L)]:+C
							i:+TDNA.C_Modification_L+1
						Case TDNA.C_PhysicalCondition_B
							If Rand(0,-G/3)=0 Then r[i+Rand(1,TDNA.C_PhysicalCondition_L)]:+C
							i:+TDNA.C_PhysicalCondition_L+1
						Case TDNA.C_Senses_B
							If Rand(0,-G/3)=0 Then r[i+Rand(1,TDNA.C_Senses_L)]:+C
							i:+TDNA.C_Senses_L+1
					End Select
					G:+1
				Next
				D._rg=r
				F=Create(Self.X,Self.Y,D)
				Self._Split=G_Step
				Self._Sat:/2
				Self._En:/3
				F._Sat=Self._Sat
				F._En=Self._En
				F._H=Self._H
				F._Split=G_Step
			End If
		Else
			'Repair
			If Self._Sat>0 And Self.A Mod C_TimeStep/2=0
				If Self._H<r[C_i_PhysCondition_Health] Then Self._H:+1
				If Self._rgDNA._Damage>0 And Self.A=0 Then Self._rgDNA._Damage:-1
			End If
			If r[C_i_Growth_InterphaseDuration]<(G_Step-Self._Split) And r[C_i_Growth_Threshold_Nutrients]<=Self._Sat And r[C_i_Growth_Threshold_Energy]<=Self._En Then Self.S=r[C_i_Growth_ProcessSpeed]
		End If
	End Method
	
	'Set Target
	Method ST(F:TCell)
		Self.T=F
	End Method
	
End Type

Type TDNA
	
	Field _rg:Byte[]
	Field _Damage:Byte
	
	'_B: Beginning of sequence, _E: End of sequence,_L: Length of Sequence
	Const C_Color_B:Byte=0
	Const C_Color_E:Byte=1
	Const C_Color_L:Byte=4
	
	Const C_SaturationVol_B:Byte=4
	Const C_SaturationVol_E:Byte=5
	Const C_SaturationVol_L:Byte=1
	
	Const C_Behaviour_B:Byte=6
	Const C_Behaviour_E:Byte=7
	Const C_Behaviour_L:Byte=1
	
	Const C_Repair_B:Byte=8
	Const C_Repair_E:Byte=9
	Const C_Repair_L:Byte=2
	
	Const C_Eating_B:Byte=10
	Const C_Eating_E:Byte=11
	Const C_Eating_L:Byte=3
	
	Const C_Storage_B:Byte=12
	Const C_Storage_E:Byte=13
	Const C_Storage_L:Byte=2
	
	Const C_Photosynthesis_B:Byte=14
	Const C_Photosynthesis_E:Byte=15
	Const C_Photosynthesis_L:Byte=2
	
	Const C_Movement_B:Byte=16
	Const C_Movement_E:Byte=17
	Const C_Movement_L:Byte=2
	
	Const C_EnergySynth_B:Byte=18
	Const C_EnergySynth_E:Byte=19
	Const C_EnergySynth_L:Byte=2
	
	Const C_Growth_B:Byte=20
	Const C_Growth_E:Byte=21
	Const C_Growth_L:Byte=4
	
	Const C_Modification_B:Byte=22
	Const C_Modification_E:Byte=23
	Const C_Modification_L:Byte=2
	
	Const C_PhysicalCondition_B:Byte=24
	Const C_PhysicalCondition_E:Byte=25
	Const C_PhysicalCondition_L:Byte=4
	
	Const C_Senses_B:Byte=26
	Const C_Senses_E:Byte=27
	Const C_Senses_L:Byte=1
	
'	Const C_:Byte=
	
	Method Stick(rg:Byte[])
		Self._rg:+rg
	End Method
	
	Method ParseDNA(Cell:TCell)
		Local r:Byte[]=Self._rg,cch:Int=r.length,i:Int,V:Byte,P:Short
		For i=0 Until cch
			p:+r[i]
			Select r[i]
				Case C_Color_B
					If Self.CFE(i,C_Color_L,C_Color_B)
						Cell._rgAttribs[TCell.C_i_Color_A]=r[i+1]
						Cell._rgAttribs[TCell.C_i_Color_R]=r[i+2]
						Cell._rgAttribs[TCell.C_i_Color_G]=r[i+3]
						Cell._rgAttribs[TCell.C_i_Color_B]=r[i+4]
						p:+r[i+2]+r[i+3]+r[i+4]
						i:+5
					Else
						V=1
					End If
				Case C_SaturationVol_B
					If Self.CFE(i,C_SaturationVol_L,C_SaturationVol_B)
						Cell._rgAttribs[TCell.C_i_Volume_Minimum]=r[i+1]
						i:+2
					Else
						V=1
					End If
				Case C_Behaviour_B
					If Self.CFE(i,C_Behaviour_L,C_Behaviour_B)
						Cell._rgAttribs[TCell.C_i_Behaviour_Aggressivity]=r[i+1]
						p:+r[i+1]/2
						i:+2
					Else
						V=1
					End If
				Case C_Repair_B
					If Self.CFE(i,C_Repair_L,C_Repair_B)
						Cell._rgAttribs[TCell.C_i_Repair_Rate]=r[i+1]
						Cell._rgAttribs[TCell.C_i_Repair_Value]=r[i+2]
						Cell._rgAttribs[TCell.C_i_Repair_Utilization]=r[i+3]
						i:+4
					Else
						V=1
					End If
				Case C_Eating_B
					If Self.CFE(i,C_Eating_L,C_Eating_B)
						Cell._rgAttribs[TCell.C_i_Eating_DigestionSpeed]=r[i+1]
						Cell._rgAttribs[TCell.C_i_Eating_UtilizationRate]=r[i+2]
						Cell._rgAttribs[TCell.C_i_Eating_Capacity]=r[i+3]
						p:+r[i+3]
						i:+4
					Else
						V=1
					End If
				Case C_Storage_B
					If Self.CFE(i,C_Storage_L,C_Storage_B)
						Cell._rgAttribs[TCell.C_i_Storage_Nutrients]=r[i+1]
						Cell._rgAttribs[TCell.C_i_Storage_Energy]=r[i+2]
						i:+3
					Else
						V=1
					End If
				Case C_Photosynthesis_B
					If Self.CFE(i,C_Photosynthesis_L,C_Photosynthesis_B)
						Cell._rgAttribs[TCell.C_i_Photosynthesis_Speed]=r[i+1]
						Cell._rgAttribs[TCell.C_i_Photosynthesis_UtilizationRate]=r[i+2]
						p:+r[i]*2+r[i+1]/2+r[i+2]/4
						i:+3
					Else
						V=1
					End If
				Case C_Movement_B
					If Self.CFE(i,C_Movement_L,C_Movement_B)
						Cell._rgAttribs[TCell.C_i_Movement_Speed]=r[i+1]
						Cell._rgAttribs[TCell.C_i_Movement_StepCost]=r[i+2]
						p:+r[i]+r[i+1]/2
						i:+3
					Else
						V=1
					End If
				Case C_EnergySynth_B
					If Self.CFE(i,C_EnergySynth_L,C_EnergySynth_B)
						Cell._rgAttribs[TCell.C_i_EnergySynthesis_Ratio]=r[i+1]
						Cell._rgAttribs[TCell.C_i_EnergySynthesis_Utilization]=r[i+2]
						p:+r[i+1]
						i:+C_EnergySynth_L+1
					Else
						V=1
					End If
				Case C_Growth_B
					If Self.CFE(i,C_Growth_L,C_Growth_B)
						Cell._rgAttribs[TCell.C_i_Growth_Threshold_Nutrients]=r[i+1]
						Cell._rgAttribs[TCell.C_i_Growth_Threshold_Energy]=r[i+2]
						Cell._rgAttribs[TCell.C_i_Growth_ProcessSpeed]=r[i+3]
						Cell._rgAttribs[TCell.C_i_Growth_InterphaseDuration]=r[i+4]
						p:+r[i+1]+r[i+2]+r[i+3]+r[i+4]*2
						i:+5
					Else
						V=1
					End If
				Case C_Modification_B
					If Self.CFE(i,C_Modification_L,C_Modification_B)
						Cell._rgAttribs[TCell.C_i_Adaptiveness_MutationResistance]=r[i+1]
						Cell._rgAttribs[TCell.C_i_Adaptiveness_AbsorptionAttendance]=r[i+2]
						p:+r[i+1]+r[i+2]
						i:+4
					Else
						V=1
					End If
				Case C_PhysicalCondition_B
					If Self.CFE(i,C_PhysicalCondition_L,C_PhysicalCondition_B)
						Cell._rgAttribs[TCell.C_i_PhysCondition_Health]=r[i+1]
						Cell._rgAttribs[TCell.C_i_PhysCondition_Defense]=r[i+2]
						Cell._rgAttribs[TCell.C_i_PhysCondition_Offense]=r[i+3]
						Cell._rgAttribs[TCell.C_i_PhysCondition_RadiationResistance]=r[i+4]
						p:+r[i+1]/2+r[i+2]/2+r[i+3]
						i:+C_PhysicalCondition_L+1
					Else
						V=1
					End If
				Case C_Senses_B
					If Self.CFE(i,C_Senses_L,C_Senses_B)
						Cell._rgAttribs[TCell.C_i_Senses_Radius]=r[i+1]
						p:+r[i+1]/4
						i:+2
					Else
						V=1
					End If
				Default
					V=1
			End Select
			If V Then Error(C_Err_Genome_Corrupt)
		Next
		Self._rg=r
		Cell._Phero=p
	End Method
	
	'CheckForEnd
	Method CFE:Byte(i:Int,L:Byte,B:Byte)
		If Self._rg[i+L+1]=B+1 Then Return True
		Return False
	End Method
	
	Method Copy:TDNA()
		Local D:TDNA=New TDNA
		D._rg=Self._rg
		Return D
	End Method
	
End Type

Const C_Err_Genome_Corrupt:Int=1
Function Error(N:Int)
	RuntimeError "Error No. "+N
End Function

Function InRange:Byte(A:Int,B:Int,C:Int)
	If Abs(A-B)<C Then Return True
	Return False
End Function

Function InRangeXY:Byte(X1:Float,Y1:Float,X2:Float,Y2:Float,R:Float)
	Local YD:Float=(Y1-Y2),XD:Float=(X1-X2)
	If XD*XD+YD*YD<=R*R Then Return True
	Return False
End Function
